
/*
 * Test on serial device
 */

////
// Include files
////
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <termios.h>
#include <fcntl.h>
#include <strings.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/file.h>
#include <linux/serial.h>

#include "serial.h"

////
// Constants
////
#define         SERIAL_DEVICE           "/dev/ttyACM0"
#define pot 0    //potentiometre
#define acc1 3   //accelerometre du
#define acc2 6
#define acc3 9


////
// Open serial port device
////

int serialOpen(char *device,int mode)
{
 int flags=(mode==SERIAL_READ?O_RDONLY:(mode==SERIAL_WRITE?O_WRONLY:O_RDWR));
 int fd=open(device,flags|O_NOCTTY);
 if(fd<0){ perror(device);exit(-1);}
 return fd;
}

////
// Serial port configuration
////

void serialConfig(int fd, int speed)
{
 struct termios new;
 bzero(&new,sizeof(new));
 new.c_cflag=CLOCAL|CREAD|speed|CS8;
 new.c_iflag=0;
 new.c_oflag=0;
 new.c_lflag=0;
 new.c_cc[VTIME]=0;
 new.c_cc[VMIN]=1;
 if(tcsetattr(fd,TCSANOW,&new)<0){perror("serialInit.tcsetattr");exit(-1);}
}

////
// Close serial port device
////

void serialClose(int fd)
{
 close(fd);
}

////
//fonction de verification du capteur
////

void capt(int capt)
{
 int donnee=0,numcapt=0,resultat=0,j,i;
 int c[12];


 for(j=0;j<12;j++)
{
 c[j]=0;
}

 if(c[capt]==97)//97 est le code ascii de a
      {
       numcapt=1;
      }
     else if(c[capt]==98)
      {
       numcapt=2;
      }
     else if(c[capt]==99)
      {
       numcapt=3;
      }
     else if(c[capt]==100)
      {
       numcapt=4;
      }
       
      if(i==capt+1)
       {
        reste=c[i];
       }
      if(i==capt+2)
       {
        resultat=c[i];
       }
     donnee=resultat*256+reste;//on reconstitue la donnée qui avait subit des opérations pour être envoyée en 2 octets binaires
	 if(numcapt==1)
     {
      printf("potentiometre= ");
     }
    else if(numcapt==2)
     {
      printf("accelerometre_bas= ");
     }
    else if(numcapt==3)
     {
      printf("accelerometre_milieu= ");
     }
    else if(numcapt==4)
     {
      printf("accelerometre_haut= ");
     }
printf("%d\n",donnee);
}



////
// Main function
////

int main(void){
while(1)
{
int se=serialOpen(SERIAL_DEVICE,SERIAL_BOTH);

for(j=0;j<12;j++)
{
 c[j]=0;
}
serialConfig(se,B9600);
for(i=0;i<12;i++){
  if(read(se,&c[i],sizeof(char))!=1){ perror("main.read"); exit(-1); }
    //potentiometre
    
   }

  if(capt_a==1)
     {
      printf("potentiometre= ");
     }
    else if(capt_a==2)
     {
      printf("accelerometre_bas= ");
     }
    else if(capt_a==3)
     {
      printf("accelerometre_milieu= ");
     }
    else if(capt_a==4)
     {
      printf("accelerometre_haut= ");
     }
printf("%d\n",donnee_a);

if(capt_b==1)
     {
      printf("potentiometre= ");
     }
    else if(capt_b==2)
     {
      printf("accelerometre_bas= ");
     }
    else if(capt_b==3)
     {
      printf("accelerometre_milieu= ");
     }
    else if(capt_b==4)
     {
      printf("accelerometre_haut= ");
     }
printf("%d\n",donnee_b);

if(capt_c==1)
     {
      printf("potentiometre= ");
     }
    else if(capt_c==2)
     {
      printf("accelerometre_bas= ");
     }
    else if(capt_c==3)
     {
      printf("accelerometre_milieu= ");
     }
    else if(capt_c==4)
     {
      printf("accelerometre_haut= ");
     }
printf("%d\n",donnee_c);

if(capt_d==1)
     {
      printf("potentiometre= ");
     }
    else if(capt_d==2)
     {
      printf("accelerometre_bas= ");
     }
    else if(capt_d==3)
     {
      printf("accelerometre_milieu= ");
     }
    else if(capt_d==4)
     {
      printf("accelerometre_haut= ");
     }
printf("%d\n",donnee_d);
printf("\n");
printf("\n");
       
serialClose(se);
//exit(0);
}
}
