#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libwebsockets.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>

#define MAX_FRAME_SIZE  1024
#define WAIT_DELAY      50

#define SERVEUR_IP "127.0.0.1"
#define SERVEUR_PORT 5555

static int callback_http(
  struct libwebsocket_context *this,
  struct libwebsocket *wsi,enum libwebsocket_callback_reasons reason,
  void *user,void *in,size_t len)
{
return 0;
}

static int callback_my(
  struct libwebsocket_context * this,
  struct libwebsocket *wsi,enum libwebsocket_callback_reasons reason,
  void *user,void *in,size_t len)
{
static char *message=NULL;
static int msize=0;

/* Creation d'un client socket famille INET */

int connexionDemon(char *serveur,unsigned short int port){
    int ds;                         /* Descripteur de SOCKET */
    struct sockaddr_in adresse;     /* Adresse du serveur */
    int statut;                     /* Stocke le statut des commandes */
    
    /* Creation de la SOCKET du client */
    ds=socket(AF_INET,SOCK_DGRAM,0);
    if(ds<0) {perror("connexionServeur.socket"); exit(-1);}
    
    /* Preparation de la structure adresse du serveur */
    struct in_addr ip;
    statut=inet_aton(serveur,&ip);
    if(statut<0) {perror("connexionServeur.inet_aton"); exit(-1);}
    adresse.sin_family=AF_INET;
    adresse.sin_addr=ip;
    adresse.sin_port=htons(port);
    
    /* Connexion au serveur */
    statut=connect(ds,(struct sockaddr *)&adresse,sizeof adresse);
    if(statut<0) {perror("connexionServeur.bind"); exit(-1);}
    
    return ds;
}

switch(reason){
  case LWS_CALLBACK_ESTABLISHED:
    printf("connection established\n");
    message=NULL;
                // Declenchement d'un prochain envoi au navigateur
    libwebsocket_callback_on_writable(this,wsi);
    break;
  case LWS_CALLBACK_RECEIVE:
                // Ici sont traites les messages envoyes par le navigateur
    printf("received data: %s\n",(unsigned char *)in);
    int ds=connexionDemon(SERVEUR_IP,SERVEUR_PORT);
    if(ds<0){ fprintf(stderr,"Serveur du bras non utilisable\n"); exit(-1); }
    if(write(ds,in,sizeof(char))!=1){ perror("main.write"); exit(-1); }
    close(ds);

    message=malloc(len+LWS_SEND_BUFFER_PRE_PADDING+LWS_SEND_BUFFER_POST_PADDING);
    if(message==NULL){ perror("callback_my.malloc"); exit(EXIT_FAILURE); }
    memcpy(message+LWS_SEND_BUFFER_PRE_PADDING,in,len);
                // Declenchement d'un prochain envoi au navigateur
    msize=len;
    libwebsocket_callback_on_writable(this,wsi);
    break;
  case LWS_CALLBACK_SERVER_WRITEABLE:
                // Ici sont envoyes les messages au navigateur
    if(message!=NULL){
      char *out=message+LWS_SEND_BUFFER_PRE_PADDING;
      libwebsocket_write(wsi,(unsigned char *)out,msize,LWS_WRITE_TEXT);
      free(message);
      message=NULL;
      }
    break;
  default:
    break;
  }
return 0;
}

static struct libwebsocket_protocols protocols[] = {
  {
    "http-only",   // name
    callback_http, // callback
    0,             // data size
    0              // maximum frame size
  },
  {"myprotocol",callback_my,0,MAX_FRAME_SIZE},
  {NULL,NULL,0,0}
  };



int main(void) {
int port=9000;
struct lws_context_creation_info info;
memset(&info,0,sizeof info);
info.port=port;
info.protocols=protocols;
info.gid=-1;
info.uid=-1;
struct libwebsocket_context *context=libwebsocket_create_context(&info);
if(context==NULL){
  fprintf(stderr, "libwebsocket init failed\n");
  return -1;
  }
printf("starting server...\n");
while(1){
  libwebsocket_service(context,WAIT_DELAY);
  }
libwebsocket_context_destroy(context);
return 0;
}
